/**
 * gen_array2_main.cpp
 *
 * Egyszerű program a generikus tömb előadáson
 * bemutatott 2. változatához (sablon paraméterként kapott fix méretű)
 *
 */
#include <iostream>
#include "gen_array2.hpp"               // sablon
using std::cout;
using std::endl;

int main() {
    try {
	  Array<int, 50> ia;                // 50 elemű int tömbök
      Array<int, 10> ia1;               // 10 elemű int tömb (az int template valtozat újból példányosodott)
	  Array<double, 10> da; 		    // double tömbök
	  Array<const char *, 5> ca;        // const char* tömb

	  ia1[0] = ia[12] = 4;
	  da[2] = 4.54;
	  ca[2] = "Hello Template";

      cout << "Int tomb 12. eleme: " << ia[12] << endl;
      cout << "double tomb 2. eleme: " << da[2] << endl;
      cout << "const char* tomb 2. eleme: " << ca[2] << endl;

      const Array<int, 10> ia2 = ia1;   // konstans
      cout << "konstans tomb 0. eleme: " << ia2[0] << endl;
      cout << "10 elemu konstans tomb 12. eleme: " << ia2[12] << endl;     // hiba
    } catch (const char *p) {           // kivétel elkapása
      cout << p << endl;
    }
	return 0;
}
