/**
 * gen_array0_main.cpp
 *
 * Egyszerű program a generikus tömb makróval megvalósított változatához.
 * Elvi lehetőség, de több sebből vérzik...
 */

#include <iostream>
#include "gen_array0_m.hpp" //declare+implement makrók
using std::cout;
using std::endl;

declare_Array(int)		    // intArray deklarációja
implement_Array(int)	    // intArray def. csak 1-szer !

declare_Array(double)	    // doubleArray deklarációja
implement_Array(double)	    // doubleArray def.  1-szer !

struct Valami {             // valamilyen osztály
    int adat;
};

declare_Array(Valami)	    // ValamiArray deklarációja
implement_Array(Valami)	    // ValamiArray def.  1-szer !

int main() {
	Array(int) ia(50), ia1(10);    	// int tömbök
	Array(double)       da;         // default méretű double tömb
	Array(Valami)       va;         // default méretű Valami tömb

	ia[12] = 4;
	da[2] = 4.54;
    va[2].adat = 55;

    cout << "Int tomb 12. eleme: " << ia[12] << endl;
    cout << "double tomb 2. eleme: " << da[2] << endl;
    cout << "Valami tomb 2. eleme: " << va[2].adat << endl;

	return 0;
}
