/**
 * generic_cmp.hpp
 *
 * generikus Összehasonlító osztályok.
 */

#ifndef  GENERIC_CMP_H
#define GENERIC_CMP_H
template<class T>
struct less {
    bool operator()(const T& a, const T& b) const {
        return a < b;                                                    }
};

template<class T>
struct greater {
    bool operator()(const T& a, const T& b) const {
        return a > b;                                                    }
};

template <typename T>
class greater_than {
    T  ref_value;
public:
    greater_than(const T& val) : ref_value(val) {}
    bool operator()(const T& a) const {
        return a > ref_value;
    }
};

#endif
